<template>
  <div class="tasks">
    <v-sheet
      tile
      height="54"
      class="d-flex"
      v-if="1===2"
    >
      <v-btn
        icon
        class="ma-2"
        @click="$refs.calendar.prev()"
      >
        <v-icon>mdi-chevron-left</v-icon>
      </v-btn>
      <div v-if="1===3">
        <v-select
          v-model="type"
          :items="types"
          dense
          outlined
          hide-details
          class="ma-2"
          label="type"
        ></v-select>
        <v-select
          v-model="mode"
          :items="modes"
          dense
          outlined
          hide-details
          label="event-overlap-mode"
          class="ma-2"
        ></v-select>
        <v-select
          v-model="weekday"
          :items="weekdays"
          dense
          outlined
          hide-details
          label="weekdays"
          class="ma-2"
        ></v-select>
      </div>
      <v-spacer></v-spacer>
      <v-spacer></v-spacer>
      <v-btn
        icon
        class="ma-2"
        @click="$refs.calendar.next()"
      >
        <v-icon>mdi-chevron-right</v-icon>
      </v-btn>
    </v-sheet>
    <v-sheet height="64">
      <v-toolbar
        flat
      >
        <v-menu bottom right>
          <template v-slot:activator="{ on, attrs }">
            <v-btn
              outlined
              color="grey darken-2"
              class="mr-4"
              v-bind="attrs"
              v-on="on"
              @click="getUsers"
              :x-small="screenWidth < 600"
            >
              <span>{{ selectedUser.username || $root.$store.state.user.username }}</span>
              <v-icon right>
                mdi-menu-down
              </v-icon>
            </v-btn>
          </template>
          <v-list>
            <v-list-item v-for="(user, index) in users" :key="user._id" @click="selectUser(user)">
              <v-list-item-title>{{user.username}}</v-list-item-title>
            </v-list-item>
          </v-list>
        </v-menu>
        <v-btn
          outlined
          class="mr-4"
          color="grey darken-2"
          @click="setToday"
          :x-small="screenWidth < 600"
        >
          Сегодня
        </v-btn>
        <div class="d-flex" :style="{flexDirection: screenWidth < 600 && 'column' || 'initial'}">
          <div>
            <v-btn
              fab
              text
              small
              color="grey darken-2"
              @click="prev"
              :x-small="screenWidth < 600"
            >
              <v-icon small :x-small="screenWidth < 600">
                mdi-chevron-left
              </v-icon>
            </v-btn>
            <v-btn
              fab
              text
              small
              color="grey darken-2"
              @click="next"
              :x-small="screenWidth < 600"
            >
              <v-icon small :x-small="screenWidth < 600">
                mdi-chevron-right
              </v-icon>
            </v-btn>
          </div>
          <v-toolbar-title v-if="$refs.calendar" class="d-flex align-center">
            <p class="ma-0" :style="{fontSize: screenWidth < 600 && '12px' || '16px'}">{{ $refs.calendar.title }}</p>
          </v-toolbar-title>
        </div>
        <v-spacer></v-spacer>
        <v-menu
          bottom
          right
        >
          <template v-slot:activator="{ on, attrs }">
            <v-btn
              outlined
              color="grey darken-2"
              v-bind="attrs"
              v-on="on"
              :x-small="screenWidth < 600"
            >
              <span>{{ typeToLabel[type] }}</span>
              <v-icon right>
                mdi-menu-down
              </v-icon>
            </v-btn>
          </template>
          <v-list>
            <v-list-item @click="type = 'day'">
              <v-list-item-title>День</v-list-item-title>
            </v-list-item>
            <v-list-item @click="type = 'week'">
              <v-list-item-title>Неделя</v-list-item-title>
            </v-list-item>
            <v-list-item @click="type = 'month'">
              <v-list-item-title>Месяц</v-list-item-title>
            </v-list-item>
            <v-list-item @click="type = '4day'">
              <v-list-item-title>4 дня</v-list-item-title>
            </v-list-item>
          </v-list>
        </v-menu>
      </v-toolbar>
    </v-sheet>
    <v-card :loading="loading">
      <v-sheet height="600">
        <v-calendar
          ref="calendar"
          v-model="focus"
          :weekdays="weekday"
          :type="type"
          :events="events"
          :event-overlap-mode="mode"
          :event-overlap-threshold="30"
          :event-color="getEventColor"
          @click:event="showEvent"
          @click:more="viewDay"
          event-more-text="Показать еще"
          @click:date="viewDay"
          locale="ru"
          @change="getEvents"
        ></v-calendar>
        <v-menu
          v-model="selectedOpen"
          :close-on-content-click="false"
          :activator="selectedElement"
          offset-x
        >
          <v-card
            color="grey lighten-4"
            min-width="350px"
            flat
          >
            <v-toolbar
              :color="selectedEvent.color"
              dark
            >
              <v-toolbar-title v-html="selectedEvent.name"></v-toolbar-title>
            </v-toolbar>
            <v-card-text v-if="selectedEvent.index >= 0">
              <div class="d-flex">
                <span class="mr-2">Название:</span>
                <span>{{task[selectedEvent.index].name || 'Нет названия'}}</span>
              </div>
              <div class="d-flex">
                <span class="mr-2">Сообщение:</span>
                <span>{{task[selectedEvent.index].message || 'Нет сообщения'}}</span>
              </div>
              <div class="d-flex align-center">
                <span class="mr-2">Автор:</span>
                <span>
                <v-chip small>
                  {{task[selectedEvent.index].from.username}}
                </v-chip>
              </span>
              </div>
              <div class="d-flex align-center">
                <span class="mr-2">Состояние:</span>
                <span>
                <v-chip small :color="task[selectedEvent.index].statusTask && 'red' || 'green'">
                  {{task[selectedEvent.index].statusTask && 'Не выполнено' || 'Выполнено ' + task[selectedEvent.index].success}}
                </v-chip>
              </span>
              </div>
            </v-card-text>
            <v-card-actions>
              <v-btn
                text
                color="secondary"
                @click="selectedOpen = false"
              >
                Закрыть
              </v-btn>
              <router-link  :to="{name: 'Lead', params: {id: selectedEvent.lead_id}}" target="_blank" class="ml-auto">
                <v-btn
                  text
                  color="secondary"
                  @click="selectedOpen = false"
                >
                  Отрыть лид
                </v-btn>
              </router-link>
            </v-card-actions>
          </v-card>
        </v-menu>
      </v-sheet>
    </v-card>
    <div style="font-size: 12px" class="mt-6">
      <div><v-chip x-small color="red" class="ml-1">красный</v-chip> - задача просрочена</div>
      <div><v-chip x-small color="orange" class="ml-1">оранжевый</v-chip> - до завершения задачи 3-5 дней</div>
      <div><v-chip x-small color="yellow" class="ml-1">желтый</v-chip> - до завершения задачи 5-7 дней</div>
      <div><v-chip x-small color="green" class="ml-1">зеленый</v-chip> - до завершения задачи более 7 дней</div>
      <div><v-chip x-small color="blue" class="ml-1">синий</v-chip> - задача выполнена</div>
    </div>
  </div>
</template>

<script>
import api from '@/API/api'
import { mapGetters } from 'vuex'

export default {
  name: 'Tasks',
  data: () => ({
    screenWidth: 0,
    loading: false,
    loadingUsers: false,
    users: [],
    selectedUser: {},
    type: 'month',
    types: ['month', 'week', 'day', '4day'],
    mode: 'stack',
    modes: ['stack', 'column'],
    weekday: [1, 2, 3, 4, 5, 6, 0],
    task: [],
    selectedEvent: {},
    selectedElement: null,
    selectedOpen: false,
    typeToLabel: {
      month: 'Месяц',
      week: 'Неделя',
      day: 'День',
      '4day': '4 Дня',
    },
    focus: '',
    weekdays: [
      { text: 'Sun - Sat', value: [0, 1, 2, 3, 4, 5, 6] },
      { text: 'Mon - Sun', value: [1, 2, 3, 4, 5, 6, 0] },
      { text: 'Mon - Fri', value: [1, 2, 3, 4, 5] },
      { text: 'Mon, Wed, Fri', value: [1, 3, 5] },
    ],
    value: '',
    events: [],
    colors: ['red', 'orange', 'yellow', 'green', 'blue', 'deep-purple', 'cyan', 'grey darken-1'],
    names: ['Meeting', 'Holiday', 'PTO', 'Travel', 'Event', 'Birthday', 'Conference', 'Party'],
  }),
  computed: {
    ...mapGetters(["USER"]),
  },
  mounted () {
    this.screenWidth = window.innerWidth;
    window.addEventListener('resize', this.handleResize);
  },
  beforeDestroy() {
    window.removeEventListener('resize', this.handleResize);
  },
  methods: {
    async getEvents () {
      this.loading = true
      if (!this.task.length) {
        await api.getTasksLead({ _id: this.selectedUser._id || this.USER._id }).then(res => {
          res.data.tasks.length && res.data.tasks.forEach(el => {
            el.messages.forEach(elem => {
              if (elem.type === 'Задача') {
                elem.lead_id = el._id
                if (this.selectedUser.roles && this.selectedUser.roles[0] !== 'ADMIN') {
                  if (this.selectedUser._id === elem.from._id && elem.statusTask) {
                    this.task.push(elem);
                  }
                } else if (this.USER.roles[0] === 'ADMIN') {
                  if (elem.statusTask) {
                    this.task.push(elem);
                  }
                } else {
                  if (this.USER._id === elem.from._id && elem.statusTask) {
                    this.task.push(elem);
                  }
                }
              }
            })
          })
        })
        for (let i = 0; i < this.task.length; i++) {
          this.events.push({
            name: this.task[i].task + ' ' + this.task[i].taskHour,
            start: new Date(this.task[i].taskDate),
            end: new Date(this.task[i].taskDate),
            color: this.colors[this.rnd(0, this.colors.length - 1, i)],
            timed: '',
            lead_id: this.task[i].lead_id,
            index: i
          })
        }
      }

      this.loading = false
    },
    async getUsers() {
      this.loadingUsers = true
      if (!this.users.length) await api.getUsers().then(res => {
        if(res.data.status) {
          this.users = res.data.users
          this.users.push({
            username: '',
            _id: '',
            name: '',
            roles: ['']
          })
        }
        this.loadingUsers = false
      })
      else return false
    },
    async selectUser (user = Object) {
      this.selectedUser = user
      this.task = []
      this.events = []
      await this.getEvents()
    },
    getEventColor (event) {
      return event.color
    },
    rnd (a, b, i) {
      const countEndDay = new Date(this.task[i].taskDate) % new Date()
      if (!this.task[i].statusTask) return 4
      else if (new Date(this.task[i].taskDate) < new Date()) return 0
      else if (countEndDay > 3 && countEndDay < 5) return 1
      else if (countEndDay > 5 && countEndDay < 7) return 2
      else if (countEndDay > 7) return 3
      // return Math.floor((b - a + 1) * Math.random()) + a
    },
    setToday () {
      this.focus = ''
    },
    viewDay ({ date }) {
      this.focus = date
      this.type = 'day'
    },
    prev () {
      this.$refs.calendar.prev()
    },
    next () {
      this.$refs.calendar.next()
    },
    showEvent ({ nativeEvent, event }) {
      const open = () => {
        this.selectedEvent = event
        this.selectedElement = nativeEvent.target
        requestAnimationFrame(() => requestAnimationFrame(() => this.selectedOpen = true))
      }

      if (this.selectedOpen) {
        this.selectedOpen = false
        requestAnimationFrame(() => requestAnimationFrame(() => open()))
      } else {
        open()
      }
      // this.$router.push({name: 'Lead', params: {id: event.lead_id}})
      nativeEvent.stopPropagation()
    },
    handleResize() {
      this.screenWidth = window.innerWidth;
    }
  },
}
</script>

<style scoped>

</style>
